Subject: Re: bug#77171: 31.0.50; Some lines in etc/HELLO display with large height on MS-Windows

From: Cecilio Pardo <[email-masked]>
Date: Thu, 3 Apr 2025 11:12:51 +0200

On 03/04/2025 7:32, Eli Zaretskii wrote:

>> The attached patch fixes this by using the GDI measurement for the
>> vertical size of text.
>>
>> Doing the same with DirectWrite would be too expensive, and would imply
>> using the "layout" parts of DirectWrite, to get the same results most of
>> the time.
> 
> Hmm... are we sure the GDI measurement will work always for the fonts
> for which we must use DirectWrite?  For example, the color fonts?
> 
> If GDI might fail for some fonts, perhaps leaving the metrics code in
> w32_dwrite_text_extents, and then _overriding_ that by GDI values if
> available, would be safer?

We get the DirectWrite font from the underlying GDI font, so GDI will 
not fail, but it will indeed give incorrect metrics from color fonts, so 
this will need some more work.

Thanks.